<?php
/**
 *
 * @package	    Pay My Bill Module
 * @subpackage	Pay My Bill Module
 * @version     1.0.0
 * @description Pay My Bill Module
 * @copyright	  Copyright © 2012 - 2015 All rights reserved.
 * @license		  GNU General Public License v2.0
 * @author		  SoftPill.Eu
 * @author mail	mail@softpill.eu
 * @website		  www.softpill.eu
 *
 */
//ini_set("display_errors",0);
//error_reporting(E_ALL);
if (version_compare(PHP_VERSION, '5.3.1', '<'))
{
	die('Your host needs to use PHP 5.3.1 or higher to run this version of Joomla!');
}
define('_JEXEC', 1);
defined( '_JEXEC' ) or die( 'Restricted access' );
define('DS', DIRECTORY_SEPARATOR);
$dirname=str_ireplace(DS.'modules'.DS.'mod_paymybill'.DS.'return','', dirname(__FILE__));
if (file_exists($dirname.DS.'defines.php'))
{
	include_once $dirname.DS.'defines.php';
}
if (!defined('_JDEFINES'))
{
	define('JPATH_BASE', $dirname);
	require_once JPATH_BASE.DS.'includes/defines.php';
}
require_once JPATH_BASE.DS.'includes/framework.php';
// Mark afterLoad in the profiler.
JDEBUG ? $_PROFILER->mark('afterLoad') : null;
// Instantiate the application.
$app = JFactory::getApplication('site');
require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."helper.php");
$PMBHelper = new PMBHelper();
$order_id=isset($_GET[ "id" ])?$_GET[ "id" ]:"";
if($order_id=="")
  die('Acces restrictionat');
$user=JFactory::getUser();
$isroot = $user->get('isRoot');
if(!$isroot)
  die('Acces restrictionat');
$module_id=0;
$tarr=explode("-",$order_id);
$module_id=$tarr[1]+0;
if($module_id==0)
  die('Acces restrictionat');
$params=$PMBHelper->getWorkingModParams($module_id);
$db=JFactory::getDbo();
$sql="select * from #__paymybill where order_id='".$db->escape($order_id)."' AND APPROVAL != '' AND RRN_Sales = '' AND RRN_Reversal = ''";
$db->setQuery($sql);
$order=$db->loadObject();
if(isset($order->id) && $order->id>0)
{
  $mode=$order->mode;
  
  $BT_KEY=$params['romcard_BT_KEY'];
  $BT_TERMINAL=$params['romcard_TERMINAL'];
  $romcard_MERCH_NAME=$params['romcard_MERCH_NAME'];
  
  $romcard_URL="https://www.secure11gw.ro/portal/cgi-bin/";//live
	
	if($mode=='TEST')
  {
    $romcard_URL="https://www.activare3dsecure.ro/teste3d/cgi-bin/";//test
  }
  
  // Campul care se va cripta
	$sData = "";
	// ORDER
	$sFieldValue = "00000" . intval( $order->id );
	AddField( $sData, $sFieldValue );
	$postFields[ "ORDER" ] = $sFieldValue;
	
	// AMOUNT
	$sFieldValue = $order->payment;
	AddField( $sData, $sFieldValue );
	$postFields[ "AMOUNT" ] = $sFieldValue;
	// CURRENCY
	$sFieldValue = $order->currency;
	AddField( $sData, $sFieldValue );
	$postFields[ "CURRENCY" ] = $sFieldValue;
	
	// RRN
	$sFieldValue = $order->RRN_Preauth;
	AddField( $sData, $sFieldValue );
	$postFields[ "RRN" ] = $sFieldValue;
	
	// INT_REF
	$sFieldValue = $order->INT_REF_Preauth;
	AddField( $sData, $sFieldValue );
	$postFields[ "INT_REF" ] = $sFieldValue;
	
	// TRTYPE
	$sFieldValue = "21";
	AddField( $sData, $sFieldValue );
	$postFields[ "TRTYPE" ] = $sFieldValue;
	
	// TERMINAL
	$sFieldValue = $BT_TERMINAL;
	AddField( $sData, $sFieldValue );
	$postFields[ "TERMINAL" ] = $sFieldValue;
	// TIMESTAMP
	$sFieldValue = gmdate( "YmdHis" );
	AddField( $sData, $sFieldValue );
	$postFields[ "TIMESTAMP" ] = $sFieldValue;
	// NONCE
	$sFieldValue = $romcard_MERCH_NAME . uniqid( "", TRUE );
	AddField( $sData, $sFieldValue );
	$postFields[ "NONCE" ] = $sFieldValue;
	// BACKREF
	$sFieldValue = JURI::base()."confirm_sale.php";
	AddField( $sData, $sFieldValue );
	$postFields[ "BACKREF" ] = $sFieldValue;
	
	// P_SIGN
	$sFieldValue = CalculateHash( $sData, $BT_KEY );
	AddField( $sData, $sFieldValue );
	$postFields[ "P_SIGN" ] = $sFieldValue;
	
	$ch = curl_init();
	curl_setopt( $ch, CURLOPT_URL, $romcard_URL );
	curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
	curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, true );
	curl_setopt( $ch, CURLOPT_POST, 1 );
	curl_setopt( $ch, CURLOPT_POSTFIELDS, $postFields );
	curl_setopt( $ch, CURLOPT_SSL_VERIFYHOST, 0 );
	$result = curl_exec( $ch );
		
	echo $result;
}
else
{
  die('Tranzactia nu exista, nu a fost aprobata, a fost anulata, sau a fost deja incasata.');
}
function AddField( &$sData, $sFieldValue )
{
	if( strlen( $sFieldValue ) == 0 )
	{
		$sData .= "-";
	}
	else
	{
		$sData .= strlen( $sFieldValue ) . $sFieldValue;
	}
}
function CalculateHash( $sData, $BT_KEY )
{
	return strtoupper( hash_hmac( "sha1", $sData, pack( 'H*', $BT_KEY ) ) );
}
?>